;~      AutoIt3Wrapper_GUI.
#Region
#AutoIt3Wrapper_Icon=icon.ico
#AutoIt3Wrapper_Res_Icon_Add=tick.ico
#AutoIt3Wrapper_Res_Icon_Add=cancel.ico
#EndRegion

#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <ButtonConstants.au3>
#include <GUIImageList.au3>
#include <file.au3>
#include <GUIConstants.au3>
#include <array.au3>
#include <Encoding.au3>
#include <GuiComboBox.au3>
#include <ListViewConstants.au3>
#include <GuiListView.au3>
#include <GuiEdit.au3>
#include <GuiIPAddress.au3>
#include <GuiListBox.au3>
#include <process.au3>
#include <ComboConstants.au3>
#Include <Icons.au3>
#include <Misc.au3>
#include <GUIMenu.au3>

Opt("TrayMenuMode", 1) ;     .

;~     
if _Singleton("test",1) = 0 Then
	MsgBox(48, "IP Changer v.3.1", '    !')
	WinActivate("IP Changer v.3.1")
    Exit
EndIf

;~      .
If IsAdmin() = 0 Then
	MsgBox(16, "IP Changer v.3.1", "     !" & @LF & "           .")
	Exit
EndIf

Global $ListView, $sLan, $GUI, $aIp, $var, $str, $iLast_LV_Index, $Item_Add, $Item_Delete, $Item_Go, $Item_Rename
Global $wIni = @ScriptDir & "\ipchanger.ini"
Dim $strMac, $strIPAddress, $IPAddress, $IPSubnet, $strIPSubnet, $DefaultIPGateway, $strDefaultIPGateway

;~      .
$GUI = GUICreate ("IP Changer v.3.1", 850, 179, -1, -1, -1)
GUISetBkColor(0x000000, $GUI)

;~     ($combo).     .
$combo = GUICtrlCreateCombo ("", 15, 140, 240, 80, $CBS_DROPDOWNLIST)
GUICtrlSetFont(-1, 10, 450)

;~    .    .
$ListView = _GUICtrlListView_Create ($GUI, "", 277, 10, 561, 160)
_GUICtrlListView_SetExtendedListViewStyle($ListView, BitOR($LVS_EX_FULLROWSELECT, $LVS_EX_GRIDLINES, $LVS_EX_TRACKSELECT, $LVS_EX_INFOTIP))
_GUICtrlListView_AddColumn ($ListView, "", 180)
_GUICtrlListView_AddColumn ($ListView, "IP", 95)
_GUICtrlListView_AddColumn ($ListView, "", 95)
_GUICtrlListView_AddColumn ($ListView, "", 95)
_GUICtrlListView_AddColumn ($ListView, "DNS", 95)

;~      (set.ini).   ,  .
$var = FileExists($wIni)
If $var=0 Then
	_FileCreate($wIni)
EndIf

;~     (set.ini) ,           ($ListView).
If $var=1 Then
	$aIniName = IniReadSection ($wIni, "name")
	_ArrayDelete($aIniName, 0)
	$iRows = UBound($aIniName, 1)
	$aIniIp = IniReadSection ($wIni, "ip")
	_ArrayDelete($aIniIp, 0)
	$aIniMask = IniReadSection ($wIni, "mask")
	_ArrayDelete($aIniMask, 0)
	$aIniGateway = IniReadSection ($wIni, "gateway")
	_ArrayDelete($aIniGateway, 0)
	$aIniDns = IniReadSection ($wIni, "dns")
	_ArrayDelete($aIniDns, 0)
	If $iRows <> 0 Then
		For $i=0 To $iRows-1 Step 1
			$var = $aIniName[$i][1]
			_GUICtrlListView_AddItem($ListView, $var)
			$var = $aIniIp[$i][1]
			_GUICtrlListView_AddSubItem($ListView, $i, $var, 1)
			$var = $aIniMask[$i][1]
			_GUICtrlListView_AddSubItem($ListView, $i, $var, 2)
			$var = $aIniGateway[$i][1]
			_GUICtrlListView_AddSubItem($ListView, $i, $var, 3)
			$var = $aIniDns[$i][1]
			_GUICtrlListView_AddSubItem($ListView, $i, $var, 4)
		Next
	EndIf
EndIf

;~       .
GUICtrlCreateGroup ("", 10, 5, 250, 165)
$label_Card = GUICtrlCreateLabel ("", 50, 20, 200, 50)
GUICtrlSetBkColor (-1, $GUI_BKCOLOR_TRANSPARENT)
GUICtrlSetColor(-1, 0xffffff)
GUICtrlCreateLabel ("IP-:", 35, 70, 100)
GUICtrlSetBkColor (-1, $GUI_BKCOLOR_TRANSPARENT)
GUICtrlSetFont(-1, 8, 500, 0, "Courier")
GUICtrlSetColor(-1, 0xffffff)
$label_IP = GUICtrlCreateLabel ("", 115, 70, 110, 15)
GUICtrlSetBkColor (-1, $GUI_BKCOLOR_TRANSPARENT)
GUICtrlSetFont(-1, 8, 500, 0, "Courier")
GUICtrlSetColor(-1, 0xffffff)
GUICtrlCreateLabel (":", 59, 85, 100)
GUICtrlSetBkColor (-1, $GUI_BKCOLOR_TRANSPARENT)
GUICtrlSetFont(-1, 8, 500, 0, "Courier")
GUICtrlSetColor(-1, 0xffffff)
$label_Mask = GUICtrlCreateLabel ($strIPSubnet, 115, 85, 110, 15)
GUICtrlSetBkColor (-1, $GUI_BKCOLOR_TRANSPARENT)
GUICtrlSetFont(-1, 8, 500, 0, "Courier")
GUICtrlSetColor(-1, 0xffffff)
GUICtrlCreateLabel (":", 67, 100, 100)
GUICtrlSetBkColor (-1, $GUI_BKCOLOR_TRANSPARENT)
GUICtrlSetFont(-1, 8, 500, 0, "Courier")
GUICtrlSetColor(-1, 0xffffff)
$label_Gateway = GUICtrlCreateLabel ($strDefaultIPGateway, 115, 100, 110, 15)
GUICtrlSetBkColor (-1, $GUI_BKCOLOR_TRANSPARENT)
GUICtrlSetFont(-1, 8, 500, 0, "Courier")
GUICtrlSetColor(-1, 0xffffff)

_Lan_Cards_Display  ($combo, $var)
$var = _MAC ($combo, $var)
_Lan_Settings_Display ($var)

;~   .
$DummyMenu = GUICtrlCreateDummy()
$ContextMenu = GUICtrlCreateContextMenu($DummyMenu)
$Item_Go = GUICtrlCreateMenuItem("GO!", $ContextMenu)
GUICtrlCreateMenuItem("", $ContextMenu, 2)
$Item_Add = GUICtrlCreateMenuItem("", $ContextMenu)
$Item_Rename = GUICtrlCreateMenuItem("", $ContextMenu)
$Item_Delete = GUICtrlCreateMenuItem("", $ContextMenu)

$1 = GUICtrlRead($combo) ;       $combo.

GUISetState(@SW_SHOW)
_GUICtrlListView_SetHoverTime($ListView, 1) ;   ,         -.
GUIRegisterMsg($WM_NOTIFY, "WM_NOTIFY") ;       .

While 1
	$msg = GUIGetMsg ()
	$2 = GUICtrlRead($combo) ;       $combo.

;~ 	  $combo        .
	If $2 <> $1 Then
		$var = _MAC ($combo, $var)
		_Lan_Settings_Display ($str)
		$1 = $2
		EndIf
	Select

;~ 		      .
		Case $msg = $Item_Add
			$aIp = 0
			_Child_Window ($GUI)

;~ 		   .
		Case $msg = $GUI_EVENT_CLOSE
			$var = _GUICtrlListView_GetItemCount($ListView)
			_FileCreate($wIni)
			IniWriteSection ($wIni, "name", "")
			IniWriteSection ($wIni, "ip", "")
			IniWriteSection ($wIni, "mask", "")
			IniWriteSection ($wIni, "gateway", "")
			IniWriteSection ($wIni, "dns", "")
			For $i=0 To $var-1 Step 1
				$aList = _GUICtrlListView_GetItemTextArray($ListView, $i)
				IniWrite($wIni, "name", $i, $aList[1])
				IniWrite($wIni, "ip", $i, $aList[2])
				IniWrite($wIni, "mask", $i, $aList[3])
				IniWrite($wIni, "gateway", $i, $aList[4])
				IniWrite($wIni, "dns", $i, $aList[5])
			Next
			Exit

;~ 		     "".
		Case $msg = $Item_Delete
			_GUICtrlListView_DeleteItemsSelected($ListView)

;~ 		     .
		Case $msg = $Item_Rename
			$var = _GUICtrlListView_GetSelectedIndices ($ListView, False)
			$aIp = _GUICtrlListView_GetItemTextArray ($ListView, $var)
			_Child_Window ($GUI)

;~ 		     "GO"      .
		Case $msg = $Item_Go
			_Set_Lan_Settings ($combo)

	EndSelect
WEnd

;~   (  $ListView)   ( $combo)   .
Func _Set_Lan_Settings ($combo)

	Local $setip1, $setip2, $sCombo, $var
	$var = _GUICtrlListView_GetSelectedIndices ($ListView, False)
	$aIp = _GUICtrlListView_GetItemTextArray ($ListView, $var)
	$sCombo = GUICtrlRead ($combo)
	GUISetState(@SW_LOCK, $GUI)
	$setip1='netsh interface ip set address name="' & $sCombo & '" source=static addr=' & $aIp[2] & ' mask=' & $aIp[3] & ' gateway=' & $aIp[4] & ' gwmetric=1'
	$setip2='netsh interface ip set dns name="' & $sCombo & '" source=static addr=' & $aIp[5] & ' register=PRIMARY'
	_RunDOS($setip1)
	_RunDOS($setip2)
	Sleep(4000)
	MsgBox(0, "",'  "' & $sCombo & '"'& @LF & @LF & "IP: " & $aIp[2] & @LF & ": " & $aIp[3] & @LF & ": " & $aIp[4] & @LF & "DNS: " & $aIp[5])
	GUISetState(@SW_UNLOCK, $GUI)
	$var = _MAC ($combo, $var)
	_Lan_Settings_Display ($str)
EndFunc

;   ($combo)     .
Func _Lan_Cards_Display ($combo, $var)

	Local $objWMIService, $colItems, $objItem
	$objWMIService = ObjGet("winmgmts:\\localhost\root\CIMV2")
	$colItems = $objWMIService.ExecQuery("SELECT * FROM Win32_NetworkAdapter", "WQL",  0x10 + 0x20)
	If IsObj($colItems) then
	   For $objItem In $colItems
			if $objItem.NetConnectionID<>'' then GUICtrlSetData ($combo, $objItem.NetConnectionID)
		Next
	Endif
	 _GUICtrlComboBox_SetCurSel($combo, 0)

EndFunc

;  - ,   $combo.
Func _MAC ($combo, $var)

	$str = GUICtrlRead($combo)
	$objWMIService = ObjGet("winmgmts:\\localhost\root\CIMV2")
	$colItems = $objWMIService.ExecQuery("SELECT * FROM Win32_NetworkAdapter", "WQL",  0x10 + 0x20)
	If IsObj($colItems) then
	   For $objItem In $colItems
			if $objItem.NetConnectionID = $str Then
				$var = $objItem.MACAddress
				Return $var
			EndIf
		Next
	Endif

EndFunc

;      .
Func _Lan_Settings_Display ($str)

	Local $objWMIService, $colItems, $objItem
	$objWMIService = ObjGet("winmgmts:{impersonationLevel=impersonate}!\\.\root\cimv2")
	$colItems = $objWMIService.ExecQuery("Select * from Win32_NetworkAdapterConfiguration")
	For $objItem In $colItems
		If $objItem.MACAddress = $var Then
			$str = $objItem.Description
			GUICtrlSetData ($label_Card, $str)
			If UBound($objItem.IPAddress) > 0 Then
				For $IPAddress In $objItem.IPAddress
					$str = $IPAddress
					GUICtrlSetData ($label_IP, $str)
				Next
			Else
				GUICtrlSetData ($label_IP, "---")
			EndIf
			If UBound($objItem.IPSubnet) > 0 Then
				For $IPSubnet In $objItem.IPSubnet
					 $str = $IPSubnet
					 GUICtrlSetData ($label_Mask, $str)
				Next
			Else
				GUICtrlSetData ($label_Mask, "---")
			EndIf
			If UBound($objItem.DefaultIPGateway) > 0 Then
				For $DefaultIPGateway In $objItem.DefaultIPGateway
					 $str = $DefaultIPGateway
					 GUICtrlSetData ($label_Gateway, $str)
				Next
		 	Else
				GUICtrlSetData ($label_Gateway, "---")
			EndIf
		EndIf
	Next

EndFunc

;~           ($ListView).
Func _Child_Window ($GUI_Main)

	Local $GUI_Child, $str
	GUISetState (@SW_DISABLE, $GUI_Main)
	$GUI_Child = GUICreate("Child GUI", 205, 250, -1, -1, $WS_POPUPWINDOW, $WS_EX_TOPMOST, $GUI_Main)
	GUISetBkColor(0xc0c0c0, $GUI_Child)
	$Icon_Ok_Child = GUICtrlCreateIcon("", 0, 25, 210, 32, 32)
	GUICtrlSetImage($Icon_Ok_Child, @ScriptFullPath, 201)
	$Icon_Cancel_Child = GUICtrlCreateIcon("", 0, 140, 210, 32, 32)
	GUICtrlSetImage($Icon_Cancel_Child, @ScriptFullPath, 202)
	Dim $Array_HotKey[2][2] = [["{ENTER}", $Icon_Ok_Child],["{ESC}", $Icon_Cancel_Child]]
	GUISetAccelerators($Array_HotKey)
	GUICtrlCreateGroup ("", 5, 2, 194, 38)
	$Input_Name = GUICtrlCreateInput ("", 12, 15, 180, 18)
	GUICtrlSetState ($Input_Name, $GUI_FOCUS)
	GUICtrlCreateGroup ("IP-", 5, 40, 124, 38)
	$Ip_Ip = _GUICtrlIpAddress_Create ($GUI_Child, 12, 53, 110, 18)
	GUICtrlCreateGroup ("", 5, 78, 124, 38)
	$Ip_Mask = _GUICtrlIpAddress_Create ($GUI_Child, 12, 91, 110, 18)
	GUICtrlCreateGroup ("", 5, 116, 124, 38)
	$Ip_Gateway = _GUICtrlIpAddress_Create ($GUI_Child, 12, 129, 110, 18)
	GUICtrlCreateGroup ("DNS", 5, 154, 124, 38)
	$Ip_Dns = _GUICtrlIpAddress_Create ($GUI_Child, 12, 167, 110, 18)
	If IsArray($aIp) = 1 Then
		GUICtrlSetData ($Input_Name, $aIp[1])
		_GUICtrlIpAddress_Set ($Ip_Ip, $aIp[2])
		_GUICtrlIpAddress_Set ($Ip_Mask, $aIp[3])
		_GUICtrlIpAddress_Set ($Ip_Gateway, $aIp[4])
		_GUICtrlIpAddress_Set ($Ip_Dns, $aIp[5])
	Else
		_GUICtrlIpAddress_Set ($Ip_Mask, "255.255.255.0")
	EndIf
	GUISetState(@SW_SHOW, $GUI_Child)
	While 1
		$msg = GUIGetMsg ()
		Select

			Case $msg = $Icon_Ok_Child
				$str = GUICtrlRead ($Input_Name)
				If IsArray ($aIp) = 0 Then
					$var = _GUICtrlListView_AddItem($ListView, $str)
				Else
					_GUICtrlListView_SetItemText ($ListView, $var, $str)
				EndIf
				$str = _GUICtrlIpAddress_Get ($Ip_Ip)
				_GUICtrlListView_AddSubItem($ListView, $var, $str, 1)
				$str = _GUICtrlIpAddress_Get ($Ip_Mask)
				_GUICtrlListView_AddSubItem($ListView, $var, $str, 2)
				$str = _GUICtrlIpAddress_Get ($Ip_Gateway)
				_GUICtrlListView_AddSubItem($ListView, $var, $str, 3)
				$str = _GUICtrlIpAddress_Get ($Ip_Dns)
				_GUICtrlListView_AddSubItem($ListView, $var, $str, 4)
				GUISetState (@SW_ENABLE, $GUI_Main)
				GUIDelete ($GUI_Child)
				ExitLoop

			Case $msg = $Icon_Cancel_Child
				GUISetState (@SW_ENABLE, $GUI_Main)
				GUIDelete ($GUI_Child)
				ExitLoop
		EndSelect
	WEnd

EndFunc

;~      .
Func WM_NOTIFY($hWnd, $iMsg, $iwParam, $ilParam)
	#forceref $hWnd, $iMsg, $iwParam
	Local $hWndFrom, $iIDFrom, $iCode, $tNMHDR, $hWndListView, $tInfo
	$hWndListView = $ListView
	If Not IsHWnd($ListView) Then $hWndListView = GUICtrlGetHandle($ListView)

	$tNMHDR = DllStructCreate($tagNMHDR, $ilParam)
	$hWndFrom = HWnd(DllStructGetData($tNMHDR, "hWndFrom"))
	$iIDFrom = DllStructGetData($tNMHDR, "IDFrom")
	$iCode = DllStructGetData($tNMHDR, "Code")
	Switch $hWndFrom
		Case $hWndListView
			Switch $iCode
				Case $LVN_COLUMNCLICK ;    
					$tInfo = DllStructCreate($tagNMLISTVIEW, $ilParam)
					_DebugPrint("$LVN_COLUMNCLICK" & @LF & "--> hWndFrom:" & @TAB & $hWndFrom & @LF & _
							"-->IDFrom:" & @TAB & $iIDFrom & @LF & _
							"-->Code:" & @TAB & $iCode & @LF & _
							"-->Item:" & @TAB & DllStructGetData($tInfo, "Item") & @LF & _
							"-->SubItem:" & @TAB & DllStructGetData($tInfo, "SubItem") & @LF & _
							"-->NewState:" & @TAB & DllStructGetData($tInfo, "NewState") & @LF & _
							"-->OldState:" & @TAB & DllStructGetData($tInfo, "OldState") & @LF & _
							"-->Changed:" & @TAB & DllStructGetData($tInfo, "Changed") & @LF & _
							"-->ActionX:" & @TAB & DllStructGetData($tInfo, "ActionX") & @LF & _
							"-->ActionY:" & @TAB & DllStructGetData($tInfo, "ActionY") & @LF & _
							"-->Param:" & @TAB & DllStructGetData($tInfo, "Param"))
					;   
				Case $LVN_KEYDOWN ;   
					$tInfo = DllStructCreate($tagNMLVKEYDOWN, $ilParam)
					_DebugPrint("$LVN_KEYDOWN" & @LF & "--> hWndFrom:" & @TAB & $hWndFrom & @LF & _
							"-->IDFrom:" & @TAB & $iIDFrom & @LF & _
							"-->Code:" & @TAB & $iCode & @LF & _
							"-->VKey:" & @TAB & DllStructGetData($tInfo, "VKey") & @LF & _
							"-->Flags:" & @TAB & DllStructGetData($tInfo, "Flags"))
					;   
				Case $NM_CLICK ;   ListView,       
					$tInfo = DllStructCreate($tagNMITEMACTIVATE, $ilParam)
					_DebugPrint("$NM_CLICK" & @LF & "--> hWndFrom:" & @TAB & $hWndFrom & @LF & _
							"-->IDFrom:" & @TAB & $iIDFrom & @LF & _
							"-->Code:" & @TAB & $iCode & @LF & _
							"-->Index:" & @TAB & DllStructGetData($tInfo, "Index") & @LF & _
							"-->SubItem:" & @TAB & DllStructGetData($tInfo, "SubItem") & @LF & _
							"-->NewState:" & @TAB & DllStructGetData($tInfo, "NewState") & @LF & _
							"-->OldState:" & @TAB & DllStructGetData($tInfo, "OldState") & @LF & _
							"-->Changed:" & @TAB & DllStructGetData($tInfo, "Changed") & @LF & _
							"-->ActionX:" & @TAB & DllStructGetData($tInfo, "ActionX") & @LF & _
							"-->ActionY:" & @TAB & DllStructGetData($tInfo, "ActionY") & @LF & _
							"-->lParam:" & @TAB & DllStructGetData($tInfo, "lParam") & @LF & _
							"-->KeyFlags:" & @TAB & DllStructGetData($tInfo, "KeyFlags"))
					;   
				Case $NM_DBLCLK ;   ListView,          
					$tInfo = DllStructCreate($tagNMITEMACTIVATE, $ilParam)
					$iIndex = DllStructGetData($tInfo, "Index")

					If $iIndex <> -1 Then
                        $iLast_LV_Index = $iIndex
						_Set_Lan_Settings ($combo)
					EndIf

					;   
				Case $NM_KILLFOCUS ;    
					_DebugPrint("$NM_KILLFOCUS" & @LF & "--> hWndFrom:" & @TAB & $hWndFrom & @LF & _
							"-->IDFrom:" & @TAB & $iIDFrom & @LF & _
							"-->Code:" & @TAB & $iCode)
					;   
				Case $NM_RCLICK ;   ListView,       
                    $tInfo = DllStructCreate($tagNMITEMACTIVATE, $ilParam)
                    $iIndex = DllStructGetData($tInfo, "Index")

					If $iIndex <> -1 Then
                        $iLast_LV_Index = $iIndex
						GUICtrlSetState ($Item_Delete, $GUI_ENABLE)
						GUICtrlSetState ($Item_Rename, $GUI_ENABLE)
						GUICtrlSetState ($Item_Go, $GUI_ENABLE)
						ShowMenu($hWnd, $ContextMenu, $ListView, 1)
					EndIf
					If $iIndex = -1 Then
;~                         $iLast_LV_Index = $iIndex
						GUICtrlSetState ($Item_Delete, $GUI_DISABLE)
						GUICtrlSetState ($Item_Rename, $GUI_DISABLE)
						GUICtrlSetState ($Item_Go, $GUI_DISABLE)
						ShowMenu($hWnd, $ContextMenu, $ListView, 1)
					EndIf

				Case $NM_RDBLCLK ;   ListView,          
					$tInfo = DllStructCreate($tagNMITEMACTIVATE, $ilParam)
					_DebugPrint("$NM_RDBLCLK" & @LF & "--> hWndFrom:" & @TAB & $hWndFrom & @LF & _
							"-->IDFrom:" & @TAB & $iIDFrom & @LF & _
							"-->Code:" & @TAB & $iCode & @LF & _
							"-->Index:" & @TAB & DllStructGetData($tInfo, "Index") & @LF & _
							"-->SubItem:" & @TAB & DllStructGetData($tInfo, "SubItem") & @LF & _
							"-->NewState:" & @TAB & DllStructGetData($tInfo, "NewState") & @LF & _
							"-->OldState:" & @TAB & DllStructGetData($tInfo, "OldState") & @LF & _
							"-->Changed:" & @TAB & DllStructGetData($tInfo, "Changed") & @LF & _
							"-->ActionX:" & @TAB & DllStructGetData($tInfo, "ActionX") & @LF & _
							"-->ActionY:" & @TAB & DllStructGetData($tInfo, "ActionY") & @LF & _
							"-->lParam:" & @TAB & DllStructGetData($tInfo, "lParam") & @LF & _
							"-->KeyFlags:" & @TAB & DllStructGetData($tInfo, "KeyFlags"))
					;   
				Case $NM_RETURN ;         ENTER
					_DebugPrint("$NM_RETURN" & @LF & "--> hWndFrom:" & @TAB & $hWndFrom & @LF & _
							"-->IDFrom:" & @TAB & $iIDFrom & @LF & _
							"-->Code:" & @TAB & $iCode)
					;   
				Case $NM_SETFOCUS ;    
					_DebugPrint("$NM_SETFOCUS" & @LF & "--> hWndFrom:" & @TAB & $hWndFrom & @LF & _
							"-->IDFrom:" & @TAB & $iIDFrom & @LF & _
							"-->Code:" & @TAB & $iCode)
					;   
			EndSwitch
	EndSwitch
	Return $GUI_RUNDEFMSG
EndFunc   ;==>WM_NOTIFY

Func _DebugPrint($s_text, $line = @ScriptLineNumber)
	ConsoleWrite( _
			"!===========================================================" & @LF & _
			"+======================================================" & @LF & _
			"-->(" & StringFormat("%04d", $line) & "):" & @TAB & $s_text & @LF & _
			"+======================================================" & @LF)
EndFunc   ;==>_DebugPrint

; Show a menu in a given GUI window which belongs to a given GUI ctrl
Func ShowMenu($hWnd, $nContextID, $nContextControlID, $iMouse=0)
    Local $hMenu = GUICtrlGetHandle($nContextID)
    Local $iCtrlPos = ControlGetPos($hWnd, "", $nContextControlID)

    Local $X = $iCtrlPos[0]
    Local $Y = $iCtrlPos[1] + $iCtrlPos[3]

    ClientToScreen($hWnd, $X, $Y)

    If $iMouse Then
        $X = MouseGetPos(0)
        $Y = MouseGetPos(1)
    EndIf

    DllCall("user32.dll", "int", "TrackPopupMenuEx", "hwnd", $hMenu, "int", 0, "int", $X, "int", $Y, "hwnd", $hWnd, "ptr", 0)
EndFunc

; Convert the client (GUI) coordinates to screen (desktop) coordinates
Func ClientToScreen($hWnd, ByRef $x, ByRef $y)
    Local $stPoint = DllStructCreate("int;int")

    DllStructSetData($stPoint, 1, $x)
    DllStructSetData($stPoint, 2, $y)

    DllCall("user32.dll", "int", "ClientToScreen", "hwnd", $hWnd, "ptr", DllStructGetPtr($stPoint))

    $x = DllStructGetData($stPoint, 1)
    $y = DllStructGetData($stPoint, 2)
    ; release Struct not really needed as it is a local
    $stPoint = 0
EndFunc
